'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* @flow */

// Imports

var _require = require('caterpillar');

var Transform = _require.Transform;

/**
Filter the log entires by level.
Extends http://rawgit.com/bevry/caterpillar/master/docs/index.html#Transform
@extends caterpillar.Transform
@example
const logger = require('caterpillar').create()
logger.pipe(require('caterpillar-filter').create()).pipe(process.stdout)
logger.log('info', 'this will be outputted')
logger.log('debug', 'this will be ignored')
logger.setConfig({level: 5})
logger.log('info', 'now even this will be ignored')
logger.log('note', 'but not this')
*/

var Filter = function (_Transform) {
	_inherits(Filter, _Transform);

	function Filter() {
		_classCallCheck(this, Filter);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(Filter).apply(this, arguments));
	}

	_createClass(Filter, [{
		key: 'getInitialConfig',


		/**
  Get the initial configuration.
  @returns {Object}
  */
		value: function getInitialConfig() {
			return {
				level: 6
			};
		}

		/**
  Empty log entries that are not within our level range.
  Convert the message from Logger into JSON, check its level, if it is above our level, discard it.
  @param {string} message
  @returns {?Object}
  */

	}, {
		key: 'format',
		value: function format(message /* :string */) {
			var entry = JSON.parse(message);

			var _getConfig = this.getConfig();

			var level = _getConfig.level;

			return entry.levelNumber > level ? null : entry;
		}
	}]);

	return Filter;
}(Transform);

// Export


module.exports = Filter;